VERSION 5.00
Begin VB.Form frmBackdatenAuswerten 
   Caption         =   "frmBackdatenAuswerten"
   ClientHeight    =   7005
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   10155
   LinkTopic       =   "Form1"
   ScaleHeight     =   7005
   ScaleWidth      =   10155
   StartUpPosition =   3  'Windows-Standard
   Begin VB.ListBox lstAusgewertet 
      Height          =   840
      Left            =   3360
      TabIndex        =   12
      Top             =   4920
      Width           =   6495
   End
   Begin VB.CommandButton cmdVerdichten 
      Caption         =   "cmdVerdichten"
      Height          =   735
      Left            =   240
      TabIndex        =   11
      Top             =   4920
      Width           =   2775
   End
   Begin VB.ListBox lstSortiert 
      Height          =   1425
      Left            =   3360
      TabIndex        =   10
      Top             =   3000
      Width           =   6495
   End
   Begin VB.CommandButton cmdSortien 
      Caption         =   "cmdSortien"
      Height          =   975
      Left            =   240
      TabIndex        =   9
      Top             =   3000
      Width           =   2775
   End
   Begin VB.TextBox txtAbsatz 
      Height          =   495
      Left            =   6360
      TabIndex        =   7
      Text            =   "txtAbsatz"
      Top             =   2280
      Width           =   2535
   End
   Begin VB.TextBox txtUmsatz 
      Height          =   495
      Left            =   3360
      TabIndex        =   5
      Text            =   "txtUmsatz"
      Top             =   2280
      Width           =   2535
   End
   Begin VB.CommandButton cmdAuswerten 
      Caption         =   "cmdAuswerten"
      Height          =   735
      Left            =   240
      TabIndex        =   4
      Top             =   2040
      Width           =   2775
   End
   Begin VB.CommandButton cmdEnde 
      Caption         =   "cmdEnde"
      Height          =   615
      Left            =   7920
      TabIndex        =   3
      Top             =   6240
      Width           =   2055
   End
   Begin VB.ListBox lstUnsortiert 
      Height          =   645
      Left            =   3360
      TabIndex        =   2
      Top             =   960
      Width           =   6495
   End
   Begin VB.CommandButton cmdAnzeigen 
      Caption         =   "cmdAnzeigen"
      Height          =   735
      Left            =   240
      TabIndex        =   1
      Top             =   960
      Width           =   2775
   End
   Begin VB.CommandButton cmdLaden 
      Caption         =   "cmdLaden"
      Height          =   495
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   2775
   End
   Begin VB.Label lblAbsatz 
      Caption         =   "lblAbsatz"
      Height          =   375
      Left            =   6360
      TabIndex        =   8
      Top             =   1920
      Width           =   2655
   End
   Begin VB.Label lblUmsatz 
      Caption         =   "lblUmsatz"
      Height          =   375
      Left            =   3360
      TabIndex        =   6
      Top             =   1920
      Width           =   2655
   End
End
Attribute VB_Name = "frmBackdatenAuswerten"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type Datensatz
    ArtNr As Single
    ArtBezeichnung As String
    ArtPreis As Double
    ArtMenge As Integer
End Type

Const Maxindex = 100
Dim Feldzeiger As Integer
Dim Satz As Datensatz
Dim Feld_1(0 To Maxindex) As Datensatz
Dim Feld_2(0 To Maxindex) As Datensatz



Private Sub Form_Load()
    frmBackdatenAuswerten.Caption = "Backdaten auswerten"
    cmdLaden.Caption = "Daten laden"
    cmdAnzeigen.Caption = "Daten anzeigen"
    lstUnsortiert.Text = ""
    cmdEnde.Caption = "Ende"
    cmdAuswerten.Caption = "Auswerten"
    txtUmsatz.Text = ""
    txtUmsatz.Locked = True
    lblUmsatz.Caption = "Umsatz"
    txtAbsatz.Text = ""
    txtAbsatz.Locked = True
    lblAbsatz.Caption = "Absatz"
    cmdSortien.Caption = "Sortieren"
    lstSortiert.Text = ""
    cmdVerdichten.Caption = "Verdichten"
    lstAusgewertet.Text = ""
    
End Sub

Private Sub cmdLaden_Click()
    Dim Pfad As String
    
    On Local Error GoTo FehlerInLaden
    Pfad = App.Path
    If Right$(Pfad, 1) = "\" Then
       Open Pfad & "daten.txt" For Input As #1
      Else
       Open Pfad & "\daten.txt" For Input As #1
    End If
    
    Feldzeiger = -1
    Do While Not EOF(1)
       Feldzeiger = Feldzeiger + 1
       Input #1, Satz.ArtNr
       Input #1, Satz.ArtBezeichnung
       Input #1, Satz.ArtPreis
       Input #1, Satz.ArtMenge
       Feld_1(Feldzeiger) = Satz
       
    Loop
    Close #1
    
    Exit Sub
    
FehlerInLaden:
    If Err = 53 Then
        Beep
        MsgBox "Die Datendatei existiert nicht!"
       Else
        MsgBox "Sonstiger Fehler mit der Nr. " & Err
    End If
    Exit Sub
End Sub

Private Sub cmdAnzeigen_Click()
    'Ausgabe des unsortierten Feldes in die Listbox
    'Die Verwendung von AddItem ist mglich
    Dim Zaehler As Integer
    For Zaehler = 0 To Feldzeiger
        lstUnsortiert.List(Zaehler) = Feld_1(Zaehler).ArtBezeichnung & " " & Feld_1(Zaehler).ArtMenge
    Next Zaehler
End Sub

Private Sub cmdAuswerten_Click()
    Dim Zaehler As Integer
    Dim UmsatzSumme As Double
    Dim Absatz As Long
    
    For Zaehler = 0 To Feldzeiger
        UmsatzSumme = UmsatzSumme + Feld_1(Zaehler).ArtMenge * Feld_1(Zaehler).ArtPreis
        Absatz = Absatz + Feld_1(Zaehler).ArtMenge
    Next Zaehler
    txtUmsatz.Text = Format(UmsatzSumme, "#.***,00")
    txtAbsatz.Text = Format(Absatz, "**0")
    
End Sub

Private Sub cmdSortien_Click()
    Felder_Kopieren
    SortAustausch
    Feld2_Anzeigen
End Sub

Private Sub Felder_Kopieren()
    Dim Zaehler As Integer
    'feld_2 = feld_1
    For Zaehler = 0 To Feldzeiger
        Feld_2(Zaehler) = Feld_1(Zaehler)
    Next Zaehler
End Sub

Private Sub SortAustausch()
    Dim ZaehlerLinks As Integer
    Dim ZaehlerRechts As Integer
    
    For ZaehlerLinks = 0 To Feldzeiger - 1
        For ZaehlerRechts = ZaehlerLinks + 1 To Feldzeiger
            If Feld_2(ZaehlerRechts).ArtNr < Feld_2(ZaehlerLinks).ArtNr Then
               tauschen Feld_2(ZaehlerRechts), Feld_2(ZaehlerLinks)
            End If
        
        Next ZaehlerRechts
    Next ZaehlerLinks
End Sub

Private Sub tauschen(Tauschfeld1 As Datensatz, Tauschfeld2 As Datensatz)
    'Die Inhalten der beiden Stze werden getauscht
    Dim Hilf As Datensatz
    Hilf = Tauschfeld1
    Tauschfeld1 = Tauschfeld2
    Tauschfeld2 = Hilf
End Sub

Private Sub Feld2_Anzeigen()
    Dim Zaehler As Integer
    For Zaehler = 0 To Feldzeiger
        lstSortiert.List(Zaehler) = Feld_2(Zaehler).ArtBezeichnung & " " & Feld_2(Zaehler).ArtMenge
    Next Zaehler
End Sub

Private Sub cmdVerdichten_Click()
    Dim Zaehler As Integer
    Dim ArtikelBezeichnung As String
    Dim ArtikelMenge As Single
    
    ArtikelBezeichnung = Feld_2(0).ArtBezeichnung
    ArtikelMenge = 0
    For Zaehler = 0 To Feldzeiger
        If ArtikelBezeichnung <> Feld_2(Zaehler).ArtBezeichnung Then
           'Ausgabe
           lstAusgewertet.AddItem ArtikelBezeichnung & " " & ArtikelMenge
           ArtikelBezeichnung = Feld_2(Zaehler).ArtBezeichnung
           ArtikelMenge = Feld_2(Zaehler).ArtMenge
           Else
            ArtikelMenge = ArtikelMenge + Feld_2(Zaehler).ArtMenge
        End If
    Next Zaehler
    lstAusgewertet.AddItem ArtikelBezeichnung & " " & ArtikelMenge
End Sub


Private Sub cmdEnde_Click()
    Unload Me
End Sub


